<template>
  <q-page class="row justify-center bg-grey-3 q-pa-sm">
    <div class="col-xl-4 col-lg-6 col-md-8 col-sm-10 col-xs-12">
      <div class="text-h4 text-weight-bolder text-grey-9 q-pa-sm q-py-xl">
        Checkout
      </div>

      <component-plan :item="plan" />

      <component-user
        v-model="user"
        :vuelidate="$v.user"
        title="Dados do Aluno"
        :has-pwd="true"
      />

      <component-address
        v-model="address"
        :vuelidate="$v.address"
        title="Endereço do Aluno"
      />

      <component-payment
        v-model="payment"
        :vuelidate="$v.payment"
      />

      <component-user
        v-if="!payment.customer.sameAsUser"
        v-model="payment.customer"
        :vuelidate="$v.payment.customer"
        title="Dados do Titular"
        :has-pwd="false"
      />

      <component-address
        v-if="!payment.customer.sameUserAddress"
        v-model="payment.customer.address"
        :vuelidate="$v.payment.customer.address"
        title="Endereço de Cobrança"
      />

      <component-terms
        v-model="terms"
        :vuelidate="$v.terms"
      />

      <div class="q-px-sm q-pt-lg q-pb-xl">
        <q-btn
          label="Finalizar Compra"
          color="primary"
          @click="save"
        />
      </div>
    </div>
  </q-page>
</template>

<script>
import { required, minLength, maxLength, minValue, email } from 'vuelidate/lib/validators'
import ComponentPlan from '../components/checkout/plan'
import ComponentUser from '../components/checkout/user'
import ComponentPayment from '../components/checkout/payment'
import ComponentAddress from '../components/checkout/address'
import ComponentTerms from '../components/checkout/terms'
import { parseToDate } from 'brazilian-values'
import _ from 'lodash'

const fullName = name => _.size(name) > 2 ? _(name).words().size() > 1 : true
const isTrue = value => !!value
const factoryAddress = JSON.stringify({
  street: '',
  streetNumber: '',
  complementary: '',
  neighborhood: '',
  zipcode: '',
  city: '',
  state: ''
})
const factoryUser = JSON.stringify({
  name: '',
  documentNumber: '',
  bornAt: '',
  phone: {
    ddd: '',
    number: ''
  },
  email: ''
})

export default {
  name: 'Checkout',
  components: {
    ComponentPlan,
    ComponentUser,
    ComponentPayment,
    ComponentAddress,
    ComponentTerms
  },
  asyncData: {
    planDefault: {},
    async plan () {
      if (!this.$route.params.planId) {
        this.$router.push('/')

        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          baseURL: process.env.API,
          url: `/Plans/${this.$route.params.planId}`,
          params: {
            filter: {
              fields: ['title', 'subtitle', 'price', 'installments']
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      user: {
        ...JSON.parse(factoryUser),
        password: ''
      },
      address: JSON.parse(factoryAddress),
      payment: {
        planId: Number(this.$route.params.planId),
        paymentMethod: 'credit_card',
        cardNumber: '',
        cardCvv: '',
        cardHolderName: '',
        cardExpirationDate: '',
        customer: {
          ...JSON.parse(factoryUser),
          address: JSON.parse(factoryAddress),
          sameAsUser: true,
          sameUserAddress: true
        }
      },
      terms: {
        accepted: false
      }
    }
  },
  watch: {
    'payment.customer.sameAsUser' (sameAsUser) {
      if (!sameAsUser) {
        _.assign(this.payment.customer, JSON.parse(factoryUser))
      }
    },
    'payment.customer.sameUserAddress' (sameUserAddress) {
      if (!sameUserAddress) {
        _.assign(this.payment.customer.address, JSON.parse(factoryAddress))
      }
    }
  },
  validations: {
    user: {
      name: {
        required,
        minLength: minLength(3),
        maxLength: maxLength(60),
        fullName
      },
      documentNumber: {
        required,
        minLength: minLength(11)
      },
      bornAt: {
        required
      },
      phone: {
        number: {
          required,
          minLength: minLength(10),
          maxLength: maxLength(11)
        }
      },
      email: {
        required,
        email
      },
      password: {
        required,
        minLength: minLength(8),
        maxLength: maxLength(24)
      }
    },
    address: {
      street: {
        required,
        minLength: minLength(1),
        maxLength: maxLength(100)
      },
      streetNumber: {
        required,
        minValue: minValue(1)
      },
      complementary: {
        maxLength: maxLength(100)
      },
      neighborhood: {
        required,
        minLength: minLength(3),
        maxLength: maxLength(100)
      },
      zipcode: {
        required,
        minLength: minLength(8)
      },
      city: {
        required,
        minLength: minLength(3),
        maxLength: maxLength(100)
      },
      state: {
        required,
        minLength: minLength(2),
        maxLength: maxLength(2)
      }
    },
    payment: {
      planId: {
        required
      },
      paymentMethod: {
        required
      },
      cardNumber: {
        required,
        minLength: minLength(16)
      },
      cardCvv: {
        required,
        minLength: minLength(3)
      },
      cardHolderName: {
        required,
        minLength: minLength(3),
        maxLength: maxLength(60),
        fullName
      },
      cardExpirationDate: {
        required,
        minLength: minLength(4)
      },
      customer: {
        name: {
          required,
          minLength: minLength(3),
          maxLength: maxLength(60),
          fullName
        },
        documentNumber: {
          required,
          minLength: minLength(11)
        },
        bornAt: {
          required
        },
        phone: {
          number: {
            required,
            minLength: minLength(10),
            maxLength: maxLength(11)
          }
        },
        email: {
          required,
          email
        },
        address: {
          street: {
            required,
            minLength: minLength(1),
            maxLength: maxLength(100)
          },
          streetNumber: {
            required,
            minValue: minValue(1)
          },
          complementary: {
            maxLength: maxLength(100)
          },
          neighborhood: {
            required,
            minLength: minLength(3),
            maxLength: maxLength(100)
          },
          zipcode: {
            required,
            minLength: minLength(8)
          },
          city: {
            required,
            minLength: minLength(3),
            maxLength: maxLength(100)
          },
          state: {
            required,
            minLength: minLength(2),
            maxLength: maxLength(2)
          }
        }
      }
    },
    terms: {
      accepted: {
        isTrue
      }
    }
  },
  methods: {
    async save () {
      if (this.payment.customer.sameAsUser) {
        _.assign(this.payment.customer, this.user)
      }

      if (this.payment.customer.sameUserAddress) {
        _.assign(this.payment.customer.address, this.address)
      }

      this.$v.user.$touch()
      this.$v.address.$touch()
      this.$v.payment.$touch()
      this.$v.terms.$touch()

      if (this.$v.user.$error || this.$v.address.$error || this.$v.payment.$error || this.$v.terms.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const user = JSON.parse(JSON.stringify(_.assign(this.user, { address: this.address })))
        const payment = JSON.parse(JSON.stringify(this.payment))

        user.bornAt = parseToDate(user.bornAt)
        user.phone.ddd = user.phone.number.substring(0, 2)
        user.phone.number = user.phone.number.substring(2)
        payment.customer.phone.ddd = payment.customer.phone.number.substring(0, 2)
        payment.customer.phone.number = payment.customer.phone.number.substring(2)

        const axiosConfig = {
          method: 'POST',
          baseURL: process.env.API,
          url: '/Payments/subscribe',
          data: { user, payment }
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Cadastro realizado com sucesso', process.env.ALUNO, true)
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }
    }
  }
}
</script>
